From 16eca8ef19c1283b7eecfa61d579018eb33d0e43 Mon Sep 17 00:00:00 2001
From: Roberto Corno <corno.roberto@gmail.com>
Date: Tue, 22 May 2012 10:54:35 +0200
Subject: [PATCH 1/3] Add 0x40 descriptor support

---
 src/Makefile.am         |    6 ++++--
 src/descriptors/dr_40.c |   18 +++++++++++-------
 2 files changed, 15 insertions(+), 9 deletions(-)

diff --git a/src/Makefile.am b/src/Makefile.am
index 356bbc2..cda6fae 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -4,7 +4,7 @@ pkgincludedir = $(includedir)/dvbpsi
 
 lib_LTLIBRARIES = libdvbpsi.la
 
-libdvbpsi_la_SOURCES = dvbpsi.c dvbpsi_private.h \
+libdvbpsi_la_SOURCES = dvbpsi.c dvbpsi_private.h custom.c \
                        psi.c \
                        demux.c \
                        descriptor.c \
@@ -13,7 +13,7 @@ libdvbpsi_la_SOURCES = dvbpsi.c dvbpsi_private.h \
 
 libdvbpsi_la_LDFLAGS = -version-info 8:0:0 -no-undefined
 
-pkginclude_HEADERS = dvbpsi.h psi.h descriptor.h demux.h \
+pkginclude_HEADERS = dvbpsi.h psi.h descriptor.h demux.h custom.h \
                      tables/pat.h tables/pmt.h tables/sdt.h tables/eit.h \
                      tables/cat.h tables/nit.h tables/tot.h tables/sis.h \
 		     tables/bat.h \
@@ -31,6 +31,7 @@ pkginclude_HEADERS = dvbpsi.h psi.h descriptor.h demux.h \
                      descriptors/dr_0d.h \
                      descriptors/dr_0e.h \
                      descriptors/dr_0f.h \
+                     descriptors/dr_40.h
                      descriptors/dr_42.h \
                      descriptors/dr_43.h \
                      descriptors/dr_44.h \
@@ -63,6 +64,7 @@ descriptors_src = descriptors/dr_02.c \
                   descriptors/dr_0d.c \
                   descriptors/dr_0e.c \
                   descriptors/dr_0f.c \
+                  descriptors/dr_40.c
                   descriptors/dr_42.c \
                   descriptors/dr_43.c \
                   descriptors/dr_44.c \
diff --git a/src/descriptors/dr_40.c b/src/descriptors/dr_40.c
index 19e12be..163b836 100644
--- a/src/descriptors/dr_40.c
+++ b/src/descriptors/dr_40.c
@@ -48,12 +48,12 @@ dvbpsi_network_name_dr_t* dvbpsi_DecodeNetworkNameDr(
     dvbpsi_network_name_dr_t * p_decoded;
 
     /* Check the tag */
-    if (!dvbpsi_CanDecodeAsDescriptor(p_descriptor, 0x40))
+    if (p_descriptor->i_tag != 0x40)
         return NULL;
 
     /* Don't decode twice */
-    if (dvbpsi_IsDescriptorDecoded(p_descriptor))
-       return p_descriptor->p_decoded;
+    if (p_descriptor->p_decoded)
+        return p_descriptor->p_decoded;
 
     /* Allocate memory */
     p_decoded = (dvbpsi_network_name_dr_t*)calloc(1, sizeof(dvbpsi_network_name_dr_t));
@@ -62,7 +62,7 @@ dvbpsi_network_name_dr_t* dvbpsi_DecodeNetworkNameDr(
 
     /* Decode data */
     p_decoded->i_name_length = p_descriptor->i_length <= 255 ?
-                               p_descriptor->i_lenght : 255;
+                               p_descriptor->i_length : 255;
     if (p_decoded->i_name_length)
         memcpy(p_decoded->i_name_byte,
                p_descriptor->p_data,
@@ -84,6 +84,7 @@ dvbpsi_descriptor_t * dvbpsi_GenNetworkNameDr(
     /* Create the descriptor */
     dvbpsi_descriptor_t * p_descriptor =
             dvbpsi_NewDescriptor(0x40, p_decoded->i_name_length, NULL);
+
     if (!p_descriptor)
         return NULL;
 
@@ -96,9 +97,12 @@ dvbpsi_descriptor_t * dvbpsi_GenNetworkNameDr(
     if (b_duplicate)
     {
         /* Duplicate decoded data */
-        p_descriptor->p_decoded =
-                dvbpsi_DuplicateDecodedDescriptor(p_descriptor->p_decoded,
-                                                  sizeof(dvbpsi_network_name_dr_t));
+        dvbpsi_network_name_dr_t * p_dup_decoded =
+                (dvbpsi_network_name_dr_t*)calloc(1, sizeof(dvbpsi_network_name_dr_t));
+        if(p_dup_decoded)
+            memcpy(p_dup_decoded, p_decoded, sizeof(dvbpsi_network_name_dr_t));
+
+        p_descriptor->p_decoded = (void*)p_dup_decoded;
     }
 
     return p_descriptor;
-- 
1.7.5.4
